<template>
  <div style="width: 100%">
    <div class="row justify-between mainDiv">
      <div class="text-h6">Sensor</div>
      <div class="row">
        <div>
          <q-btn
            label="Sensor type"
            class="btn"
            outline
            @click="sensorTypeBtn()"
          />
        </div>
        <div style="width: 10px"></div>
        <div>
          <q-btn
            label="Add new sensor"
            class="btn"
            outline
            @click="sensorAddBtn()"
          />
        </div>
      </div>
    </div>
    <q-dialog v-model="sensorTypeDia" persistent>
      <q-card class="sensorTypeDia q-pa-md">
        <div class="row justify-between">
          <div class="text-h6">Sensor type</div>
          <div>
            <q-btn
              round
              color="secondary"
              icon="fa-solid fa-plus"
              @click="showAddSensor()"
            />
          </div>
        </div>
        <hr />
        <div class="mainSensor">
          <div class="row bg-grey q-pa-sm" style="width: 100%">
            <div class="col">Type</div>
            <div style="width: 70px">Edit</div>
            <div style="width: 70px">Delete</div>
          </div>
          <div
            class="row sensorRow q-px-sm"
            v-for="(item, index) in sensorData"
            :key="index"
          >
            <div class="col">{{ item.typeName }}</div>

            <div
              style="width: 70px"
              class="cursor-pointer"
              @click="editSensorType(item.id, item.typeName)"
            >
              <u>Edit</u>
            </div>
            <div
              style="width: 70px"
              class="cursor-pointer"
              @click="deleteSensorType(item.id)"
            >
              <u>Delete</u>
            </div>
          </div>
        </div>
        <div align="center">
          <q-btn label="Close" outline class="btn" @click="closeSensorType()" />
        </div>
      </q-card>
    </q-dialog>

    <q-dialog v-model="addSensorTypeDia" persistent>
      <q-card class="addSensor">
        <div class="text-h6 q-pa-sm">Add new sensor type</div>
        <hr />
        <div class="row">
          <div style="width: 150px" class="q-px-md q-pt-md">Type name</div>
          <div style="width: 300px">
            <q-input v-model="addSensorType" dense />
          </div>
        </div>
        <div class="row justify-center q-pt-md">
          <div>
            <q-btn
              label="cancel"
              outline
              class="btn"
              @click="closeAddSensor()"
            />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="Save"
              class="btn"
              color="secondary"
              @click="saveAddSensor()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>

    <q-dialog v-model="addNewSensorDia" persistent>
      <q-card class="addNewSensor">
        <div class="text-h6 q-pa-sm">Add new sensor</div>
        <hr />
        <div class="row">
          <div style="width: 150px" class="q-px-md q-pt-md">Sensor name</div>
          <div style="width: 300px">
            <q-input v-model="sensorName" dense />
          </div>
        </div>
        <div class="row">
          <div style="width: 150px" class="q-px-md q-pt-md">Sensor type</div>
          <div style="width: 300px">
            <q-select
              v-model="sensorType"
              :options="sensorTypeOption"
              dense
              emit-value
              map-options
            />
          </div>
        </div>
        <div class="row justify-center q-pt-md">
          <div>
            <q-btn
              label="cancel"
              outline
              class="btn"
              @click="closeSensorData()"
            />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="Save"
              class="btn"
              color="secondary"
              @click="saveSensorData()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>

    <q-dialog v-model="editSensorTypeDia" persistent>
      <q-card class="addSensor">
        <div class="text-h6 q-pa-sm">Edit sensor type</div>
        <hr />
        <div class="row">
          <div style="width: 150px" class="q-px-md q-pt-md">Type name</div>
          <div style="width: 300px">
            <q-input v-model="editSensorTypeInput" dense />
          </div>
        </div>
        <div class="row justify-center q-pt-md">
          <div>
            <q-btn
              label="cancel"
              outline
              class="btn"
              @click="closeEditSensor()"
            />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="Save"
              class="btn"
              color="secondary"
              @click="saveEditSensor()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      sensorTypeDia: false,
      addSensorTypeDia: false,
      addNewSensorDia: false,
      editSensorTypeDia: false,
      sensorData: [],
      addSensorType: "",
      editSensorTypeInput: "",
      editSensorTypeId: "",
      sensorName: "",
      sensorType: "",
      sensorTypeOption: [],
    };
  },
  methods: {
    sensorAddBtn() {
      this.sensorName = "";
      this.loadSensorTypeList();
      this.addNewSensorDia = true;
    },
    async saveEditSensor() {
      if (this.editSensorTypeInput.length == 0) {
        this.redNotify("Please input type name");
        return;
      }
      let dataSend = {
        id: this.editSensorTypeId,
        typeName: this.editSensorTypeInput,
      };
      let url = this.apiPath + "editSensorType.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.loadSensorType();
      this.editSensorTypeDia = false;
      this.sensorTypeDia = true;
    },
    closeEditSensor() {
      this.editSensorTypeDia = false;
      this.sensorTypeDia = true;
    },
    editSensorType(id, typeName) {
      this.editSensorTypeInput = typeName;
      this.editSensorTypeId = id;
      this.editSensorTypeDia = true;
      this.sensorTypeDia = false;
    },
    async deleteSensorType(id) {
      this.$q
        .dialog({
          title: "Confirm",
          message: "Would you like to delete this sensor type?",
          cancel: true,
          persistent: true,
        })
        .onOk(async () => {
          let dataSend = {
            id: Number(id),
          };
          let url = this.apiPath + "delSensorType.php";
          let res = await axios.post(url, JSON.stringify(dataSend));
          this.loadSensorType();
        });
    },
    async saveAddSensor() {
      if (this.addSensorType.length == 0) {
        this.redNotify("Please input type name");
        return;
      }
      let dataSend = {
        sensorType: this.addSensorType,
      };
      let url = this.apiPath + "addSensorType.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.loadSensorType();
      this.addSensorTypeDia = false;
      this.sensorTypeDia = true;
    },
    closeAddSensor() {
      this.addSensorTypeDia = false;
      this.sensorTypeDia = true;
    },
    closeSensorType() {
      this.sensorTypeDia = false;
      this.loadSensorTypeList();
      this.$emit("refreshData");
    },
    sensorTypeBtn() {
      this.loadSensorType();
      this.sensorTypeDia = true;
    },
    showAddSensor() {
      this.sensorTypeDia = false;
      this.addSensorTypeDia = true;
    },
    async loadSensorType() {
      this.sensorData = [];
      let url = this.apiPath + "loadSensorType.php";
      let res = await axios.get(url);
      this.sensorData = res.data;
      this.sensorData.sort((a, b) => (a.typeName > b.typeName ? 1 : -1));
    },
    closeSensorData() {
      this.addNewSensorDia = false;
    },
    async loadSensorTypeList() {
      this.sensorTypeOption = [];
      let url = this.apiPath + "loadSensorType.php";
      let res = await axios.get(url);
      res.data.forEach((x) => {
        let temp = {
          value: x.id,
          label: x.typeName,
        };
        this.sensorTypeOption.push(temp);
      });
      this.sensorType = this.sensorTypeOption[0].value;
    },
    async saveSensorData() {
      if (this.sensorName.length == 0) {
        this.redNotify("Please input sensor name");
        return;
      }
      if (this.sensorType.length == 0) {
        this.redNotify("Please input sensor type");
        return;
      }
      let dataSend = {
        sensorName: this.sensorName,
        sensorType: this.sensorType,
        projectID: this.$q.localStorage.getItem("projectInfo").projectID,
      };

      let url = this.apiPath + "saveSensorData.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.greenNotify("Add new sensor complete");
      this.addNewSensorDia = false;
      this.$emit("refreshData");
    },
  },
  mounted() {
    this.loadSensorType();
    this.loadSensorTypeList();
  },
};
</script>

<style lang="scss" scoped>
.mainDiv {
  width: 100%;
  padding: 10px;
}
.btn {
  width: 150px;
}
.sensorTypeDia {
  width: 500px;
  height: 500px;
}
.sensorRow {
  height: 30px;
  line-height: 30px;
}
.mainSensor {
  height: 370px;
  width: 100%;
  overflow-y: auto;
}
.addSensor {
  width: 500px;
  height: 180px;
}
.addNewSensor {
  width: 500px;
  height: 220px;
}
</style>
